package se.su.dsv.scipro.daisyExternal.http;

import scala.Option;
import se.su.dsv.scipro.io.dto.*;

import javax.ws.rs.core.Response;
import java.io.InputStream;
import java.util.List;
import java.util.Optional;
import java.util.Set;

public interface DaisyAPI {
    Set<ProjectParticipant> getContributors(Long projectId);

    Set<StudentProjectParticipant> getAuthors(Long projectId);

    Set<Thesis> getProjects(Long personId);

    Set<Unit> getSubUnits(Long unitId);

    Set<UserName> getUsernames(Long personId);

    List<ResearchArea> getResearchAreas(Long personId);

    List<Person> getSupervisors(Long unitId);

    Option<Person> findPersonById(Long id);

    Optional<Person> findByUsername(String userName);

    Response addContributor(Long projectId, ProjectParticipant contributor);

    Response deleteContributor(Long projectId, Long personId);

    Response createProject(Thesis project);

    Response addAuthor(Long projectId, StudentProjectParticipant author);

    Response deleteProject(Long projectId);

    Response getStudent(Long id);

    Program getProgram(Long id);

    se.su.dsv.scipro.util.Option<Thesis> getThesis(Long projectIdentifier);

    void updateThesis(Thesis thesis);

    void deleteAuthor(Long projectId, Long authorId);

    Option<String> getGradeForStudentInCourse(Long authorId, Long courseId);

    List<Person> findByPersonnummer(String personnummer);

    PhotoResult getPhoto(Long personId, final long requesterId, final boolean alwaysShow);

    se.su.dsv.scipro.util.Option<ThesisPublication> getPublication(long projectId);

    boolean sendPublication(long projectId, ThesisPublication publication);

    boolean sendPublicationFile(long projectId, String filename, long length, InputStream data);
}
