package se.su.dsv.scipro.daisyExternal.http;

import java.io.InputStream;
import java.util.function.Function;
import java.util.function.Supplier;

public abstract class PhotoResult {

    public abstract <X> X fold(final Supplier<X> missing, final Supplier<X> forbidden, final Function<InputStream, X> found);

    public static class Missing extends PhotoResult {
        @Override
        public <X> X fold(final Supplier<X> missing, final Supplier<X> forbidden, final Function<InputStream, X> found) {
            return missing.get();
        }
    }

    static class Forbidden extends PhotoResult {
        @Override
        public <X> X fold(final Supplier<X> missing, final Supplier<X> forbidden, final Function<InputStream, X> found) {
            return forbidden.get();
        }
    }

    static class Found extends PhotoResult {
        private final InputStream photo;

        Found(final InputStream photo) {
            this.photo = photo;
        }

        @Override
        public <X> X fold(final Supplier<X> missing, final Supplier<X> forbidden, final Function<InputStream, X> found) {
            return found.apply(photo);
        }
    }

}
