package se.su.dsv.scipro.file;

import lombok.Data;
import lombok.EqualsAndHashCode;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.system.DomainObject;

import javax.persistence.*;

@Data
@EqualsAndHashCode(callSuper = true)
@Entity
@Table(name = "project_file")
@SuppressWarnings("PMD.UnusedPrivateField")
public class ProjectFile extends DomainObject {

    @Id
    @GeneratedValue
    private Long id;

    @ManyToOne
    private Project project;

    @Enumerated(EnumType.STRING)
    private FileSource fileSource = FileSource.FILES;

    @OneToOne
    private FileDescription fileDescription;
}
