package se.su.dsv.scipro.grading;

import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.databind.DeserializationContext;
import com.fasterxml.jackson.databind.JsonDeserializer;
import com.fasterxml.jackson.databind.exc.InvalidFormatException;

import java.io.IOException;
import java.time.DateTimeException;
import java.time.LocalDate;
import java.time.ZoneId;
import java.util.Date;

public class LocalDateDeserializer extends JsonDeserializer<Date> {
    @Override
    public Date deserialize(final JsonParser p, final DeserializationContext ctxt) throws IOException {
        final String value = p.getValueAsString();
        try {
            return Date.from(LocalDate.parse(value).atStartOfDay().atZone(ZoneId.systemDefault()).toInstant());
        }
        catch (DateTimeException e) {
            throw new InvalidFormatException(p, "Invalid LocalDate (yyyy-MM-dd)", value, Date.class);
        }
    }
}
