package se.su.dsv.scipro.match;

import se.su.dsv.scipro.system.AbstractServiceImpl;

import javax.inject.Inject;
import javax.inject.Provider;
import javax.persistence.EntityManager;

class PreliminaryMatchServiceImpl extends AbstractServiceImpl<PreliminaryMatch, Long> implements PreliminaryMatchService {
    private final IdeaService ideaService;

    @Inject
    protected PreliminaryMatchServiceImpl(
            final Provider<EntityManager> em,
            final IdeaService ideaService)
    {
        super(em, PreliminaryMatch.class, QPreliminaryMatch.preliminaryMatch);
        this.ideaService = ideaService;
    }

    @Override
    public PreliminaryMatch findByIdea(final Idea idea) {
        return findOne(QPreliminaryMatch.preliminaryMatch.idea.eq(idea));
    }

    @Override
    public void completePreliminaryMatch(final IdeaService.Filter filter) {
        final Iterable<Idea> ideas = ideaService.findAll(filter);
        for (Idea idea : ideas) {
            final PreliminaryMatch byIdea = findByIdea(idea);
            if (byIdea != null
                    && byIdea.getSupervisor() != null
                    && idea.getMatch().getSupervisor() == null
                    && idea.getType() == Idea.Type.STUDENT)
            {
                ideaService.changeSupervisor(idea, byIdea.getSupervisor(), null);
            }
        }
    }
}
