package se.su.dsv.scipro.plagiarism;

import se.su.dsv.scipro.file.FileDescription;
import se.su.dsv.scipro.system.AbstractServiceImpl;

import javax.inject.Inject;
import javax.inject.Provider;
import javax.persistence.EntityManager;
import java.util.Optional;

class PlagiarismRequestRepositoryImpl extends AbstractServiceImpl<PlagiarismRequest, Long> implements PlagiarismRequestRepository {
    @Inject
    PlagiarismRequestRepositoryImpl(final Provider<EntityManager> em) {
        super(em, PlagiarismRequest.class, QPlagiarismRequest.plagiarismRequest);
    }

    @Override
    public Optional<PlagiarismRequest> findByFileDescription(final FileDescription file) {
        final PlagiarismRequest plagiarismRequest =
                findOne(QPlagiarismRequest.plagiarismRequest.fileDescription.eq(file));
        return Optional.ofNullable(plagiarismRequest);
    }
}
