package se.su.dsv.scipro.plagiarism.urkund;

import java.time.Duration;

enum PollingDelay {
    FIRST(Duration.ofMinutes(30)),
    SECOND(Duration.ofHours(1)),
    THIRD(Duration.ofHours(2)),
    FOURTH(Duration.ofHours(4)),
    PERPETUITY(Duration.ofHours(8));

    private final Duration duration;

    PollingDelay(final Duration duration) {
        this.duration = duration;
    }

    public Duration getDuration() {
        return duration;
    }

    public PollingDelay next() {
        switch (this) {
            case FIRST:
                return SECOND;
            case SECOND:
                return THIRD;
            case THIRD:
                return FOURTH;
            case FOURTH:
            case PERPETUITY:
            default:
                return PERPETUITY;
        }
    }
}
