package se.su.dsv.scipro.plagiarism.urkund;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Value;

import java.time.LocalDateTime;
import java.util.Optional;
import java.util.function.Function;

@Value
class SubmissionInfo implements UrkundResponse {
    @JsonProperty("Id")
    private int id;
    @JsonProperty("ExternalId")
    private String externalId;
    @JsonProperty("Timestamp")
    private LocalDateTime submitted;
    @JsonProperty("Filename")
    private String filename;
    @JsonProperty("MimeType")
    private String mimeType;
    @JsonProperty("Status")
    private StatusInfo status;
    @JsonProperty("Document")
    private Optional<DocumentInfo> document;
    @JsonProperty("Report")
    private Optional<ReportInfo> report;
    @JsonProperty("Subject")
    private String subject;
    @JsonProperty("Message")
    private String message;
    @JsonProperty("Anonymous")
    private boolean anonymous;

    @Override
    public <X> X fold(final Function<ErrorInfo, X> ifError, final Function<SubmissionInfo, X> ifSubmission) {
        return ifSubmission.apply(this);
    }
}
