package se.su.dsv.scipro.plagiarism.urkund;

import javax.inject.Inject;
import javax.inject.Provider;
import javax.persistence.EntityManager;
import java.util.Optional;

class UrkundSettingsRepositoryImpl implements UrkundSettingsRepository {
    private final Provider<EntityManager> entityManagerProvider;

    @Inject
    UrkundSettingsRepositoryImpl(final Provider<EntityManager> entityManagerProvider) {
        this.entityManagerProvider = entityManagerProvider;
    }

    @Override
    public UrkundSettings getSettings() {
        final UrkundSettings urkundSettings = entityManagerProvider.get()
                .find(UrkundSettings.class, UrkundSettings.ID);
        return Optional.ofNullable(urkundSettings).orElse(new UrkundSettings());
    }

    @Override
    public UrkundSettings save(final UrkundSettings urkundSettings) {
        final EntityManager em = entityManagerProvider.get();
        if (em.contains(urkundSettings)) {
            return em.merge(urkundSettings);
        }
        else {
            em.persist(urkundSettings);
            return urkundSettings;
        }
    }
}
