package se.su.dsv.scipro.system;


import com.querydsl.core.types.EntityPath;
import com.querydsl.jpa.impl.JPAQuery;

import javax.inject.Provider;
import javax.persistence.EntityManager;

public class AbstractRepository {

    private final Provider<EntityManager> em;

    protected AbstractRepository(Provider<EntityManager> em) {
        this.em = em;
    }

    protected <T> JPAQuery<T> from(EntityPath<T> path) {
        return new JPAQuery<T>(em.get()).from(path);
    }

    protected EntityManager em() {
        return em.get();
    }
}
