package se.su.dsv.scipro.system;

import com.querydsl.jpa.impl.JPAQuery;

import javax.inject.Inject;
import javax.inject.Provider;
import javax.persistence.EntityManager;
import java.util.List;

public class ExternalResourceServiceImpl implements ExternalResourceService {
    private final Provider<EntityManager> em;

    @Inject
    public ExternalResourceServiceImpl(final Provider<EntityManager> em) {
        this.em = em;
    }

    @Override
    public List<ExternalResource> findBy(final ProjectType projectType) {
        return new JPAQuery<ExternalResource>(em.get())
                .from(QExternalResource.externalResource)
                .where(QExternalResource.externalResource.relevantFor.eq(projectType))
                .fetch();
    }
}
