CREATE TABLE project_file (
  id BIGINT(20) NOT NULL AUTO_INCREMENT,
  dateCreated DATETIME NOT NULL,
  lastModified DATETIME NOT NULL,
  version INT(11) NOT NULL,
  fileDescription_id BIGINT(20) NOT NULL,
  project_id BIGINT(20) NOT NULL,
  fileSource VARCHAR(255) NOT NULL,
  PRIMARY KEY (id),
  FOREIGN KEY FK_project_file_file_description (fileDescription_id) REFERENCES file_description (id),
  FOREIGN KEY FK_project_file_project (project_id) REFERENCES project (id)
) ENGINE = InnoDB DEFAULT CHARSET = utf8;

UPDATE file_description SET fileSource = 'FILES' WHERE project_id IS NOT NULL AND fileSource IS NULL;

INSERT INTO project_file (dateCreated, lastModified, version, fileDescription_id, project_id, fileSource)
    SELECT dateCreated, lastModified, version, id, project_id, fileSource FROM file_description WHERE project_id IS NOT NULL;

ALTER TABLE file_description
  DROP FOREIGN KEY file_description_project,
  DROP COLUMN project_id,
  DROP COLUMN fileSource,
  DROP COLUMN deletable;
