ALTER TABLE projectPartner
  ADD COLUMN `applicationPeriod_id` BIGINT(20) NULL,
  ADD CONSTRAINT `FK_ProjectPartner_ApplicationPeriod_applicationPeriod`
    FOREIGN KEY `FK_ProjectPartner_ApplicationPeriod_applicationPeriod` (applicationPeriod_id) REFERENCES ApplicationPeriod (id);

UPDATE projectPartner SET applicationPeriod_id = (
    SELECT id
    FROM ApplicationPeriod
    WHERE DATEDIFF(endDate, startDate) > 10 -- Periods which were open for at least 10 days (aka not the dummy ones before exemptions)
      AND courseStartDate > projectPartner.dateCreated
      AND projectPartner.projectType_id IN (
          SELECT projectType_id
          FROM ApplicationPeriodProjectType
          WHERE applicationPeriod_id = ApplicationPeriod.id
    )
    ORDER BY courseStartDate ASC
    LIMIT 1
);

DELETE FROM projectPartner WHERE applicationPeriod_id IS NULL;

ALTER TABLE projectPartner
    MODIFY COLUMN `applicationPeriod_id` BIGINT(20) NOT NULL;
