INSERT INTO grading_criterion_template (dateCreated, lastModified, version, title, gradingReportTemplate_id, sortOrder, pointsRequiredToPass, type, fx)
    SELECT NOW(), NOW(), 0, 'Ö6 Reflection', id, 18, 1, 'IndividualGradingCriterionTemplate', FALSE FROM grading_report_template;

INSERT INTO grading_criterion_point_template (dateCreated, lastModified, version, gradingCriterionTemplate_id, point, description)
    SELECT NOW(), NOW(), 0, id, 0, NULL FROM grading_criterion_template WHERE title = 'Ö6 Reflection';

INSERT INTO grading_criterion_point_template (dateCreated, lastModified, version, gradingCriterionTemplate_id, point, description)
    SELECT NOW(), NOW(), 0, id, 1, 'is required: that the ability to reflect about the thesis work has been demonstrated through the individual writing of a reflection document' FROM grading_criterion_template WHERE title = 'Ö6 Reflection';

CREATE TEMPORARY TABLE rm_gr (id INT);

INSERT INTO rm_gr
SELECT id
FROM GradingReport
WHERE project_id IN (SELECT id FROM project WHERE dateCreated > '2017-01-01')
  AND NOT EXISTS (SELECT 1 FROM GradingCriterion WHERE (LENGTH(feedback) > 1 OR points IS NOT NULl) AND gradingReport_id = GradingReport.id);

DELETE FROM GradingCriterionPoint
WHERE GradingCriterion_id IN (
  SELECT id FROM GradingCriterion WHERE gradingReport_id IN (
    SELECT id FROM rm_gr));

DELETE FROM GradingCriterion
WHERE gradingReport_id IN (
  SELECT id FROM rm_gr);

DELETE FROM SupervisorGradingReport WHERE id IN (SELECT id FROM rm_gr);
DELETE FROM ReviewerGradingReport WHERE id IN (SELECT id FROM rm_gr);

DELETE FROM rm_gr;

INSERT INTO rm_gr
  SELECT id
  FROM GradingReport
  WHERE project_id IN (SELECT id FROM project WHERE dateCreated > '2017-01-01')
        AND EXISTS (SELECT 1 FROM GradingCriterion WHERE (LENGTH(feedback) > 1 OR points IS NOT NULl) AND gradingReport_id = GradingReport.id);

INSERT INTO GradingCriterion (dateCreated, lastModified, version, points, gradingReport_id, feedback, title, sortOrder, pointsRequiredToPass, type, fx)
    SELECT NOW(), NOW(), 0, NULL, id, NULL, 'Ö6 Reflection', 18, 1, 'IndividualGradingCriterion', FALSE FROM rm_gr;

INSERT INTO GradingCriterionPoint (dateCreated, lastModified, version, GradingCriterion_id, point, description)
    SELECT NOW(), NOW(), 0, id, 0, NULL FROM GradingCriterion WHERE title = 'Ö6 Reflection';

INSERT INTO GradingCriterionPoint (dateCreated, lastModified, version, GradingCriterion_id, point, description)
    SELECT NOW(), NOW(), 0, id, 1, 'is required: that the ability to reflect about the thesis work has been demonstrated through the individual writing of a reflection document' FROM GradingCriterion WHERE title = 'Ö6 Reflection';

DROP TABLE rm_gr;
