package se.su.dsv.scipro.plagiarism.urkund;

import com.google.inject.AbstractModule;
import com.google.inject.Module;
import org.junit.Test;
import se.su.dsv.scipro.sukat.SukatModule;
import se.su.dsv.scipro.test.GuiceTest;

import javax.inject.Inject;

import static org.junit.Assert.assertEquals;

public class UrkundSettingsRepositoryTest extends GuiceTest {
    @Inject
    private UrkundSettingsRepository urkundSettingsRepository;

    @Override
    protected Module moduleUnderTest() {
        return new AbstractModule() {
            @Override
            protected void configure() {
                install(new SukatModule());
                install(new UrkundModule());
            }
        };
    }

    @Test
    public void change_settings() throws Exception {
        final UrkundSettings settings = urkundSettingsRepository.getSettings();
        settings.setEnabled(true);
        settings.setUsername("bob");
        settings.setPassword("foobar");
        final UrkundSettings updated = urkundSettingsRepository.save(settings);
        final UrkundSettings new_ = urkundSettingsRepository.getSettings();

        assertEquals(new_.isEnabled(), updated.isEnabled());
        assertEquals(new_.getUsername(), updated.getUsername());
        assertEquals(new_.getPassword(), updated.getPassword());
    }
}