package se.su.dsv.scipro.integration.daisy;

import com.google.inject.multibindings.Multibinder;
import com.google.inject.servlet.ServletModule;
import se.su.dsv.scipro.integration.daisy.workers.ProjectExporter;
import se.su.dsv.scipro.integration.daisy.workers.UserImportWorker;
import se.su.dsv.scipro.io.ExternalExporter;
import se.su.dsv.scipro.io.impl.ExternalExporterDaisyImpl;
import se.su.dsv.scipro.match.IdeaCreationJudge;
import se.su.dsv.scipro.system.UserSearchService;

public class DaisyModule extends ServletModule {
    @Override
    protected void configureServlets() {
        Multibinder<IdeaCreationJudge> judges = Multibinder.newSetBinder(binder(), IdeaCreationJudge.class);
        judges.addBinding().to(Daisy.class);

        bind(ExternalExporter.class).to(ExternalExporterDaisyImpl.class);
        bind(UserImportWorker.class);
        bind(ProjectExporter.class);
        bind(DaisyWorkerInitialization.class).asEagerSingleton();

        Multibinder.newSetBinder(binder(), UserSearchService.class)
                .addBinding().to(DaisyUserSearchService.class);
    }

}
