package se.su.dsv.scipro.admin.pages.settings;

import org.apache.wicket.markup.html.form.CheckBox;
import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.markup.html.form.TextField;
import org.apache.wicket.model.CompoundPropertyModel;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.LoadableDetachableModel;
import se.su.dsv.scipro.admin.pages.AbstractAdminSystemPage;
import se.su.dsv.scipro.plagiarism.urkund.UrkundSettings;
import se.su.dsv.scipro.plagiarism.urkund.UrkundSettingsRepository;

import javax.inject.Inject;

public class AdminUrkundSettingsPage extends AbstractAdminSystemPage {
    @Inject
    private UrkundSettingsRepository urkundSettingsRepository;

    public AdminUrkundSettingsPage() {
        add(new UrkundSettingsForm("form", getSettings()));
    }

    private IModel<UrkundSettings> getSettings() {
        return new LoadableDetachableModel<UrkundSettings>() {
            @Override
            protected UrkundSettings load() {
                return urkundSettingsRepository.getSettings();
            }
        };
    }

    private class UrkundSettingsForm extends Form<UrkundSettings> {
        public UrkundSettingsForm(final String id, final IModel<UrkundSettings> settings) {
            super(id, new CompoundPropertyModel<>(settings));

            add(new CheckBox("enabled"));
            add(new TextField<>("username"));
            add(new TextField<>("password"));
        }

        @Override
        protected void onSubmit() {
            success("Saved");
            urkundSettingsRepository.save(getModelObject());
        }
    }
}
