package se.su.dsv.scipro.applicationperiod;

import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.list.ListItem;
import org.apache.wicket.markup.html.list.PropertyListView;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.model.CompoundPropertyModel;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.PropertyModel;
import se.su.dsv.scipro.components.DateLabel;
import se.su.dsv.scipro.components.ListAdapterModel;
import se.su.dsv.scipro.match.ApplicationPeriod;
import se.su.dsv.scipro.system.ProjectType;

public class ApplicationPeriodInfoPanel extends Panel {
    static final String PROJECT_TYPES = "projectTypes";
    static final String START_DATE = "startDate";
    static final String END_DATE = "endDate";
    static final String COURSE_START_DATE = "courseStartDate";
    static final String NAME = "name";

    public ApplicationPeriodInfoPanel(String id, IModel<ApplicationPeriod> applicationPeriod) {
        super(id, new CompoundPropertyModel<>(applicationPeriod));
        add(new Label(NAME));

        add(new PropertyListView<ProjectType>(PROJECT_TYPES, new ListAdapterModel<>(new PropertyModel<>(applicationPeriod, "projectTypes"))) {
            @Override
            protected void populateItem(ListItem<ProjectType> item) {
                item.add(new Label(NAME));
            }
        });

        add(new DateLabel(START_DATE));
        add(new DateLabel(END_DATE));
        add(new DateLabel(COURSE_START_DATE));
    }
}
