package se.su.dsv.scipro.components;

import org.apache.wicket.model.IModel;
import org.apache.wicket.model.Model;
import org.wicketstuff.select2.ChoiceProvider;
import se.su.dsv.scipro.security.auth.roles.Roles;
import se.su.dsv.scipro.system.User;
import se.su.dsv.scipro.system.UserRepo;

import javax.inject.Inject;

public abstract class AuthorAutoComplete extends AjaxAutoCompleteChoice<User> {

    @Inject
    private UserRepo studentService;

    public AuthorAutoComplete(String id) {
        super(id);
        setModel(new Model<User>());
        setType(User.class);
    }

    public AuthorAutoComplete(final String id, final IModel<User> model) {
        super(id, model);
    }

    @Override
    protected ChoiceProvider<User> getChoiceProvider() {
        return new AutoCompleteRoleProvider(studentService, Roles.AUTHOR);
    }

}
