package se.su.dsv.scipro.components;

import org.apache.wicket.model.IModel;
import org.wicketstuff.select2.Select2MultiChoice;
import se.su.dsv.scipro.security.auth.roles.Roles;
import se.su.dsv.scipro.system.User;
import se.su.dsv.scipro.system.UserRepo;

import javax.inject.Inject;
import java.util.Collection;

public class CoAuthorChoice extends Select2MultiChoice<User> {

    @Inject
    private UserRepo studentService;

    public CoAuthorChoice(String id, IModel<Collection<User>> model) {
        super(id, model);
        setType(User.class);
        setProvider(new AutoCompleteRoleProvider(studentService, Roles.AUTHOR));
    }

    @Override
    protected void onInitialize() {
        super.onInitialize();
        getSettings().setCloseOnSelect(true);
        getSettings().setMinimumInputLength(2);
    }
}
