package se.su.dsv.scipro.components;

import org.apache.wicket.model.Model;
import org.wicketstuff.select2.ChoiceProvider;
import org.wicketstuff.select2.Response;
import se.su.dsv.scipro.match.Keyword;
import se.su.dsv.scipro.match.KeywordService;

import javax.inject.Inject;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

public abstract class KeywordAutoComplete extends AjaxAutoCompleteChoice<Keyword> {

    @Inject
    private KeywordService keywordService;

    public KeywordAutoComplete(String id) {
        super(id);
        setModel(new Model<Keyword>());
    }

    @Override
    public boolean getAllowClear() {
        return false;
    }

    @Override
    protected ChoiceProvider<Keyword> getChoiceProvider() {
        return new KeywordProvider();
    }

    private class KeywordProvider extends ChoiceProvider<Keyword> {

        @Override
        public String getDisplayValue(Keyword choice) {
            return choice.getKeyword();
        }

        @Override
        public String getIdValue(Keyword choice) {
            return String.valueOf(choice.getId());
        }

        @Override
        public void query(String term, int page, Response<Keyword> response) {
            response.addAll(keywordService.getAutoCompleteKeywords(term, MAX_RESULTS));
        }

        @Override
        public Collection<Keyword> toChoices(Collection<String> ids) {
            List<Keyword> keywords = new ArrayList<>();
            for(String id : ids) {
                keywords.add(keywordService.findOne(Long.valueOf(id)));
            }
            return keywords;
        }
    }
}
