package se.su.dsv.scipro.loginlogout.pages;

import org.apache.wicket.markup.html.link.BookmarkablePageLink;
import se.su.dsv.scipro.basepages.PublicPage;
import se.su.dsv.scipro.generalsystemsettings.GeneralSystemSettingsService;
import se.su.dsv.scipro.system.UserService;

import javax.inject.Inject;

public class LoginPage extends PublicPage {

    @Inject
    private UserService userService;
    @Inject
    private GeneralSystemSettingsService systemSettingsService;

    public LoginPage() throws Exception {
        if (userService.count() == 0) {
            setResponsePage(FirstTimeRegistrationPage.class);
        }
        else if (!systemSettingsService.getGeneralSystemSettingsInstance().isShowSingleSignOn()) {
            setResponsePage(LocalLogInPage.class);
        }

        add(new BookmarkablePageLink<>("su", SSOPage.class));
    }
}
