package se.su.dsv.scipro.loginlogout.pages;

import se.su.dsv.scipro.basepages.PublicPage;
import se.su.dsv.scipro.daisyExternal.ExternalImporter;
import se.su.dsv.scipro.security.auth.Authorization;
import se.su.dsv.scipro.session.SciProSession;
import se.su.dsv.scipro.system.User;
import se.su.dsv.scipro.system.UserService;

import javax.inject.Inject;
import javax.servlet.http.HttpServletRequest;
import java.util.Optional;

@Authorization(requiresLoggedInUser = false)
public class SSOPage extends PublicPage {

    @Inject
    private ExternalImporter externalImporter;

    @Inject
    private UserService userService;

    public SSOPage() {
        String remoteUserName = ((HttpServletRequest) getRequest().getContainerRequest()).getRemoteUser();
        User user = userService.findByUsername(remoteUserName);

        if (user != null) {
            SciProSession.get().setUser(user);
            continueToOriginalDestination();
            setResponsePage(getApplication().getHomePage());
        } else {
            Optional<User> optionalUser = externalImporter.importUser(remoteUserName);

            if (optionalUser.isPresent() && optionalUser.get().getEmailAddress() != null) {
                SciProSession.get().setUser(optionalUser.get());
                continueToOriginalDestination();
                setResponsePage(getApplication().getHomePage());
            }
        }
    }
}
