package se.su.dsv.scipro.match;

import org.apache.commons.lang3.StringUtils;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.model.AbstractReadOnlyModel;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.PropertyModel;

public class IdeaTholanderInfoPanel extends Panel {

    public IdeaTholanderInfoPanel(String id, IModel<Idea> model) {
		super(id, model);
        add(new Label("background", replaceEmpty(new PropertyModel<>(model, "tholanderBox.background"))));
        add(new Label("literature", replaceEmpty(new PropertyModel<>(model, "tholanderBox.literature"))));
        add(new Label("problem", replaceEmpty(new PropertyModel<>(model, "tholanderBox.problem"))));
        add(new Label("method", replaceEmpty(new PropertyModel<>(model, "tholanderBox.method"))));
        add(new Label("interests", replaceEmpty(new PropertyModel<>(model, "tholanderBox.interests"))));
    }

    private IModel<String> replaceEmpty(final IModel<String> inner) {
        return new AbstractReadOnlyModel<String>() {
            @Override
            public String getObject() {
                final String value = inner.getObject();
                return StringUtils.isNotEmpty(value) ? value : getString("waiting");
            }
        };
    }
}
